import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { Message, MessageParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageMessage(params: MessageParam) {
  const res = await request.get<ApiResult<PageResult<Message>>>(
    MODULES_API_URL + '/shop/message/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listMessage(params?: MessageParam) {
  const res = await request.get<ApiResult<Message[]>>(
    MODULES_API_URL + '/shop/message',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addMessage(data: Message) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/message',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateMessage(data: Message) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/message',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeMessage(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/message/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchMessage(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/message/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getMessage(id: number) {
  const res = await request.get<ApiResult<Message>>(
    MODULES_API_URL + '/shop/message/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
